\documentclass[twoside]{book}

% Packages required by doxygen
\usepackage{calc}
\usepackage{doxygen}
\usepackage{graphicx}
\usepackage[utf8]{inputenc}
\usepackage{makeidx}
\usepackage{multicol}
\usepackage{multirow}
\usepackage{textcomp}
\usepackage[table]{xcolor}

% Font selection
\usepackage[T1]{fontenc}
\usepackage{mathptmx}
\usepackage[scaled=.90]{helvet}
\usepackage{courier}
\usepackage{amssymb}
\usepackage{sectsty}
\renewcommand{\familydefault}{\sfdefault}
\allsectionsfont{%
  \fontseries{bc}\selectfont%
  \color{darkgray}%
}
\renewcommand{\DoxyLabelFont}{%
  \fontseries{bc}\selectfont%
  \color{darkgray}%
}

% Page & text layout
\usepackage{geometry}
\geometry{%
  a4paper,%
  top=2.5cm,%
  bottom=2.5cm,%
  left=2.5cm,%
  right=2.5cm%
}
\tolerance=750
\hfuzz=15pt
\hbadness=750
\setlength{\emergencystretch}{15pt}
\setlength{\parindent}{0cm}
\setlength{\parskip}{0.2cm}
\makeatletter
\renewcommand{\paragraph}{%
  \@startsection{paragraph}{4}{0ex}{-1.0ex}{1.0ex}{%
    \normalfont\normalsize\bfseries\SS@parafont%
  }%
}
\renewcommand{\subparagraph}{%
  \@startsection{subparagraph}{5}{0ex}{-1.0ex}{1.0ex}{%
    \normalfont\normalsize\bfseries\SS@subparafont%
  }%
}
\makeatother

% Headers & footers
\usepackage{fancyhdr}
\pagestyle{fancyplain}
\fancyhead[LE]{\fancyplain{}{\bfseries\thepage}}
\fancyhead[CE]{\fancyplain{}{}}
\fancyhead[RE]{\fancyplain{}{\bfseries\leftmark}}
\fancyhead[LO]{\fancyplain{}{\bfseries\rightmark}}
\fancyhead[CO]{\fancyplain{}{}}
\fancyhead[RO]{\fancyplain{}{\bfseries\thepage}}
\fancyfoot[LE]{\fancyplain{}{}}
\fancyfoot[CE]{\fancyplain{}{}}
\fancyfoot[RE]{\fancyplain{}{\bfseries\scriptsize Generated on Fri Mar 20 2015 11\-:26\-:10 for T\-I\-M\-L by Doxygen }}
\fancyfoot[LO]{\fancyplain{}{\bfseries\scriptsize Generated on Fri Mar 20 2015 11\-:26\-:10 for T\-I\-M\-L by Doxygen }}
\fancyfoot[CO]{\fancyplain{}{}}
\fancyfoot[RO]{\fancyplain{}{}}
\renewcommand{\footrulewidth}{0.4pt}
\renewcommand{\chaptermark}[1]{%
  \markboth{#1}{}%
}
\renewcommand{\sectionmark}[1]{%
  \markright{\thesection\ #1}%
}

% Indices & bibliography
\usepackage{natbib}
\usepackage[titles]{tocloft}
\setcounter{tocdepth}{3}
\setcounter{secnumdepth}{5}
\makeindex

% Hyperlinks (required, but should be loaded last)
\usepackage{ifpdf}
\ifpdf
  \usepackage[pdftex,pagebackref=true]{hyperref}
\else
  \usepackage[ps2pdf,pagebackref=true]{hyperref}
\fi
\hypersetup{%
  colorlinks=true,%
  linkcolor=blue,%
  citecolor=blue,%
  unicode%
}

% Custom commands
\newcommand{\clearemptydoublepage}{%
  \newpage{\pagestyle{empty}\cleardoublepage}%
}


%===== C O N T E N T S =====

\begin{document}

% Titlepage & ToC
\hypersetup{pageanchor=false}
\pagenumbering{roman}
\begin{titlepage}
\vspace*{7cm}
\begin{center}%
{\Large T\-I\-M\-L }\\
\vspace*{1cm}
{\large Generated by Doxygen 1.8.6}\\
\vspace*{0.5cm}
{\small Fri Mar 20 2015 11:26:10}\\
\end{center}
\end{titlepage}
\clearemptydoublepage
\tableofcontents
\clearemptydoublepage
\pagenumbering{arabic}
\hypersetup{pageanchor=true}

%--- Begin generated contents ---
\chapter{Introduction}
\label{index}\hypertarget{index}{}\input{index}
\chapter{Module Index}
\input{modules}
\chapter{Data Structure Index}
\input{annotated}
\chapter{File Index}
\input{files}
\chapter{Module Documentation}
\input{group__appCNNClass}
\include{group__appCNNConvertImageNet}
\include{group__appCNNConvertSBD}
\include{group__appCNNInteropCaffe}
\include{group__appCNNScene}
\include{group__benchmarkCNNClass}
\include{group__cnn}
\include{group__util}
\include{group__testCNN}
\include{group__testUtil}
\include{group__app}
\include{group__appCNN}
\include{group__benchmark}
\include{group__benchmarkCNN}
\include{group__test}
\chapter{Data Structure Documentation}
\input{struct__timlCNNLayer__}
\input{struct__timlConvNeuralNetwork__}
\input{structappCNNSceneDataSet}
\input{structtimlCNNConvParams}
\input{structtimlCNNDataSet}
\input{structtimlCNNDropoutParams}
\input{structtimlCNNInputParams}
\input{structtimlCNNLinearParams}
\input{structtimlCNNNonlinearParams}
\input{structtimlCNNNormParams}
\input{structtimlCNNPoolingParams}
\input{structtimlCNNTrainingParams}
\input{structtimlUtilImage}
\input{structtimlUtilImageSet}
\input{structtimlUtilInitializer}
\chapter{File Documentation}
\input{appCNNClass_8h}
\input{appCNNClassCIFAR10Testing_8c}
\input{appCNNClassCIFAR10Training_8c}
\input{appCNNClassImageNetAlexNetTesting_8c}
\input{appCNNClassImageNetCaffeNetTesting_8c}
\input{appCNNClassImageNetCaffeNetTraining_8c}
\input{appCNNClassImageNetVGGNetTesting_8c}
\input{appCNNClassMNISTTesting_8c}
\input{appCNNClassMNISTTraining_8c}
\input{appCNNConvertImageNet_8cpp}
\input{appCNNConvertImageNet_8hpp}
\input{appCNNConvertSBD_8cpp}
\input{appCNNConvertSBD_8hpp}
\input{appCNNConvertSBDShuffle_8cpp}
\input{appCNNInteropCaffe_8cpp}
\input{appCNNInteropCaffe_8hpp}
\input{appCNNInteropCaffeConvert_8cpp}
\input{appCNNInteropCaffeConvLayerConvert_8cpp}
\input{appCNNInteropCaffeConvLayerPermuteKernel_8cpp}
\input{appCNNInteropCaffeDropoutLayerConvert_8cpp}
\input{appCNNInteropCaffeFillBlockDiagonalMatrix_8cpp}
\input{appCNNInteropCaffeFlipKernelMatrix_8cpp}
\input{appCNNInteropCaffeFlipMatrixFloat_8cpp}
\input{appCNNInteropCaffeLayerTypeConvert_8cpp}
\input{appCNNInteropCaffeLinearLayerConvert_8cpp}
\input{appCNNInteropCaffeNonlinearLayerConvert_8cpp}
\input{appCNNInteropCaffeNonlinearTypeConvert_8cpp}
\input{appCNNInteropCaffeNormLayerConvert_8cpp}
\input{appCNNInteropCaffePermuteMean_8cpp}
\input{appCNNInteropCaffePoolingLayerConvert_8cpp}
\input{appCNNInteropCaffePoolingTypeConvert_8cpp}
\input{appCNNInteropCaffeReadMean_8cpp}
\input{appCNNInteropCaffeReadProtoFromBinaryFile_8cpp}
\input{appCNNInteropCaffeReadProtoFromTextFile_8cpp}
\input{appCNNScene_8h}
\input{appCNNSceneAccuracy_8c}
\input{appCNNSceneClassify_8c}
\input{appCNNSceneClassifyOpenMP_8c}
\input{appCNNSceneGetLabel_8c}
\input{appCNNSceneGetPatch_8c}
\input{appCNNSceneLabelMatrix_8c}
\input{appCNNSceneSBDTesting_8c}
\input{appCNNSceneSBDTraining_8c}
\input{appCNNSceneShuffleIdx_8c}
\input{appCNNSceneSupervisedTraining_8c}
\input{benchmarkCNNClass_8h}
\input{benchmarkCNNClassCaffeNetTesting_8c}
\input{benchmarkCNNClassVGGNetTesting_8c}
\input{testCNN_8c}
\input{testCNN_8h}
\input{testCNNSimpleClone_8c}
\input{testCNNSimpleIO_8c}
\input{testCNNSimpleProfile_8c}
\input{testCNNSimpleResize_8c}
\input{testCNNSimpleShare_8c}
\input{testCNNSimpleTraining_8c}
\input{testUtil_8c}
\input{testUtil_8h}
\input{testUtilBLAS_8c}
\input{testUtilConv2_8c}
\input{testUtilSort_8c}
\input{timl_8h}
\input{timlCNN_8h}
\input{timlCNNAddConvLayer_8c}
\input{timlCNNAddDropoutLayer_8c}
\input{timlCNNAddInputLayer_8c}
\input{timlCNNAddLinearLayer_8c}
\input{timlCNNAddNonlinearLayer_8c}
\input{timlCNNAddNormLayer_8c}
\input{timlCNNAddPoolingLayer_8c}
\input{timlCNNAssignDevice_8c}
\input{timlCNNBackPropagation_8c}
\input{timlCNNClassifyTop1SingleMode_8c}
\input{timlCNNClassifyTopNBatchMode_8c}
\input{timlCNNClassifyTopNBatchModeOpenMP_8c}
\input{timlCNNClassifyTopNTeamModeOpenMP_8c}
\input{timlCNNClone_8c}
\input{timlCNNConvBackPropagation_8c}
\input{timlCNNConvForwardPropagation_8c}
\input{timlCNNConvInitialize_8c}
\input{timlCNNConvParamsDefault_8c}
\input{timlCNNConvReadFromBinaryFile_8c}
\input{timlCNNConvReadFromTextFile_8c}
\input{timlCNNConvShareParams_8c}
\input{timlCNNConvUpdateParams_8c}
\input{timlCNNConvWriteToFile_8c}
\input{timlCNNCostWithLabel_8c}
\input{timlCNNCreateConvNeuralNetwork_8c}
\input{timlCNNDelete_8c}
\input{timlCNNDeleteConvLayer_8c}
\input{timlCNNDeleteDropoutLayer_8c}
\input{timlCNNDeleteInputLayer_8c}
\input{timlCNNDeleteLinearLayer_8c}
\input{timlCNNDeleteNonlinearLayer_8c}
\input{timlCNNDeleteNormLayer_8c}
\input{timlCNNDeletePoolingLayer_8c}
\input{timlCNNDropoutBackPropagation_8c}
\input{timlCNNDropoutForwardPropagation_8c}
\input{timlCNNDropoutInitialize_8c}
\input{timlCNNDropoutReadFromTextFile_8c}
\input{timlCNNDropoutWriteToFile_8c}
\input{timlCNNForwardPropagation_8c}
\input{timlCNNGetLayerNum_8c}
\input{timlCNNGetParamsNum_8c}
\input{timlCNNInitialize_8c}
\input{timlCNNInputInitialize_8c}
\input{timlCNNInputParamsDefault_8c}
\input{timlCNNInputReadFromBinaryFile_8c}
\input{timlCNNInputReadFromTextFile_8c}
\input{timlCNNInputShareParams_8c}
\input{timlCNNInputWriteToFile_8c}
\input{timlCNNLayerTypeStr_8c}
\input{timlCNNLinearBackPropagation_8c}
\input{timlCNNLinearForwardPropagation_8c}
\input{timlCNNLinearInitialize_8c}
\input{timlCNNLinearParamsDefault_8c}
\input{timlCNNLinearReadFromBinaryFile_8c}
\input{timlCNNLinearReadFromTextFile_8c}
\input{timlCNNLinearShareParams_8c}
\input{timlCNNLinearUpdateParams_8c}
\input{timlCNNLinearWriteToFile_8c}
\input{timlCNNMaxPoolingBackPropagation_8c}
\input{timlCNNMaxPoolingForwardPropagation_8c}
\input{timlCNNMeanPoolingBackPropagation_8c}
\input{timlCNNMeanPoolingForwardPropagation_8c}
\input{timlCNNMemory_8c}
\input{timlCNNMemPoolSize_8c}
\input{timlCNNNonlinearBackPropagation_8c}
\input{timlCNNNonlinearForwardPropagation_8c}
\input{timlCNNNonlinearInitialize_8c}
\input{timlCNNNonlinearParamsDefault_8c}
\input{timlCNNNonlinearReadFromTextFile_8c}
\input{timlCNNNonlinearWriteToFile_8c}
\input{timlCNNNormBackPropagation_8c}
\input{timlCNNNormForwardPropagation_8c}
\input{timlCNNNormInitialize_8c}
\input{timlCNNNormParamsDefault_8c}
\input{timlCNNNormWriteToFile_8c}
\input{timlCNNPoolingBackPropagation_8c}
\input{timlCNNPoolingForwardPropagation_8c}
\input{timlCNNPoolingInitialize_8c}
\input{timlCNNPoolingParamsDefault_8c}
\input{timlCNNPoolingReadFromTextFile_8c}
\input{timlCNNPoolingWriteToFile_8c}
\input{timlCNNPrint_8c}
\input{timlCNNProfile_8c}
\input{timlCNNReadFromFile_8c}
\input{timlCNNReset_8c}
\input{timlCNNResetConvLayer_8c}
\input{timlCNNResetDropoutLayer_8c}
\input{timlCNNResetInputLayer_8c}
\input{timlCNNResetLinearLayer_8c}
\input{timlCNNResetNonlinearLayer_8c}
\input{timlCNNResetNormLayer_8c}
\input{timlCNNResetPoolingLayer_8c}
\input{timlCNNResize_8c}
\input{timlCNNSetMode_8c}
\input{timlCNNShareParams_8c}
\input{timlCNNSupervisedTrainingWithLabelBatchMode_8c}
\input{timlCNNSupervisedTrainingWithLabelBatchModeOpenMP_8c}
\input{timlCNNTrainingParamsDefault_8c}
\input{timlCNNTrainingParamsReadFromTextFile_8c}
\input{timlCNNTrainingParamsWriteToFile_8c}
\input{timlCNNUpdateParams_8c}
\input{timlCNNWriteToFile_8c}
\input{timlUtil_8h}
\input{timlUtilBLAS_8c}
\input{timlUtilClassifyAccuracy_8c}
\input{timlUtilConv2Full_8c}
\input{timlUtilConv2ImageReshape_8c}
\input{timlUtilConv2ImageReshapeBack_8c}
\input{timlUtilConv2ImageReshapeIndex_8c}
\input{timlUtilConv2Valid_8c}
\input{timlUtilCorr2Full_8c}
\input{timlUtilDiffTime_8c}
\input{timlUtilElementWiseFunction_8c}
\input{timlUtilElementWiseMultiply_8c}
\input{timlUtilFread_8c}
\input{timlUtilFree_8c}
\input{timlUtilFwrite_8c}
\input{timlUtilLocalContrastNormalize_8c}
\input{timlUtilLocalContrastUnnormalize_8c}
\input{timlUtilMalloc_8c}
\input{timlUtilMasking_8c}
\input{timlUtilMaxPooling_8c}
\input{timlUtilMeanPooling_8c}
\input{timlUtilMeanSquareError_8c}
\input{timlUtilMultinomialCrossEntropy_8c}
\input{timlUtilRandContinuousUniformRNG_8c}
\input{timlUtilRandDiscreteUniformRNG_8c}
\input{timlUtilRandNormalRNG_8c}
\input{timlUtilRandPerm_8c}
\input{timlUtilReadCIFAR10_8c}
\input{timlUtilReadFixedSizeJPEG_8c}
\input{timlUtilReadJPEG_8c}
\input{timlUtilReadMNIST_8c}
\input{timlUtilRelu_8c}
\input{timlUtilReluDerivative_8c}
\input{timlUtilReverseEndian32_8c}
\input{timlUtilScanJPEG_8c}
\input{timlUtilSigmoid_8c}
\input{timlUtilSigmoidDerivative_8c}
\input{timlUtilSoftmax_8c}
\input{timlUtilSubtract_8c}
\input{timlUtilTanh_8c}
\input{timlUtilTanhDerivative_8c}
\input{timlUtilTransform_8c}
\input{timlUtilUndoMaxPooling_8c}
\input{timlUtilUndoMeanPooling_8c}
\input{timlUtilUnmasking_8c}
\input{timlUtilVectorMaxFloat_8c}
\input{timlUtilVectorMaxIndexFloat_8c}
\input{timlUtilVectorResetFloat_8c}
\input{timlUtilVectorResetInt_8c}
\input{timlUtilVectorSortFloat_8c}
\input{timlUtilVectorSortIndexFloat_8c}
\input{timlUtilVectorSumFloat_8c}
%--- End generated contents ---

% Bibliography
\newpage
\phantomsection
\addcontentsline{toc}{chapter}{Bibliography}
\bibliographystyle{plain}
\bibliography{timl}

% Index
\newpage
\phantomsection
\addcontentsline{toc}{chapter}{Index}
\printindex

\end{document}
